package anynt.exercise.settings;


/**
 * It represents the type of interaction of the exercise to know when it will be over.
 * With this type it will be over after a maximum number of interactions
 * 
 * @author Javier
 * @since 11/04/2011
 */
public class NumberOfInteractionsInteractionType extends InteractionType
{
	// Object attributes
	/**
	 * Number of interactions when the exercise will be over
	 */
	private int maxInteractions;


	// Constructors
	public NumberOfInteractionsInteractionType(int interactions)
	{
		interaction = 0;
		maxInteractions = interactions;
	}

	// Object functions
	/**
	 * It checks if the interactions are over
	 */
	public boolean checkOver()
	{
		return interaction == maxInteractions;
	}
}