package anynt.exercise.settings;


/**
 * It represents the interface of the wait between interactions
 * It waits a time specified
 * 
 * @author Javier
 * @since 11/04/2011
 */
public class TimeDelayWaiting implements StepWaiting
{
	// Object attributes
	/**
	 * Time that the execution will be stopped
	 */
	private long timeDelay;


	// Constructors
	/**
	 * There is no time waiting
	 */
	public TimeDelayWaiting()
	{
		this(0);
	}
	/**
	 * Several second will be waited
	 */
	public TimeDelayWaiting(long time)
	{
		timeDelay = time * 1000;
	}

	// Treatment of object attributes
	public void setTimeDelay(long time)
	{
		timeDelay = time * 1000;
	}


	// Object functions
	/**
	 * The object will be interrupted the indicated time
	 */
	public void waitStep()
	{
		if (timeDelay == 0)
			return;

		try
		{
			synchronized (this)
			{
				wait(timeDelay);
			}
		}
		catch (Exception e)
		{
			
		}
	}
}