package anynt.exercise.settings;


/**
 * It represents the type of interaction of the exercise to know when it will be over.
 * With this type the exercise will be over after a specified time in seconds.
 * 
 * @author Javier
 * @since 11/04/2011
 */
public class TimeLimitInteractionType extends InteractionType
{
	// Object attributes
	/**
	 * Moment when the exercise is started
	 */
	private long startTimeInteractions;
	/**
	 * Maximum time of the exercise
	 */
	private final long maxTimeInteractions;


	// Constructors
	public TimeLimitInteractionType(long time)
	{
		maxTimeInteractions = time* 1000;
	}

	// Object functions
	public void start()
	{
		super.start();
		startTimeInteractions = System.currentTimeMillis();
	}
	/**
	 * It checks if the interactions are over
	 */
	public boolean checkOver()
	{
		return System.currentTimeMillis() - startTimeInteractions >= maxTimeInteractions;
	}
}