package anynt.object.behaviour;


import java.util.Collection;
import java.util.Random;

import distribution.IDistribution;
import distribution.UniformDistribution;

import anynt.space.Observation;


/**
 * It extends the behavior of an agent to represent a random behavior
 * 
 * @author Javier
 * @since 31/03/2011
 */
public class RandomBehaviour extends AgentBehaviour
{
	// Object overrides
	public RandomBehaviour clone()
	{
		return new RandomBehaviour();
	}

	// AgentBehaviour overrides
	public int nextAction(Observation observation)
	{
		// It actualizes the time that is spend to realize the action
		long maximumTime = agent.getMaximumTimeToAct();
		elapsedTime += new Random().nextLong() % (maximumTime + 1);

		// The Random Agent makes a random action
		IDistribution uniformDistribution = new UniformDistribution();
		Collection<Integer> actions = availableActions();

		return (Integer) actions.toArray()[uniformDistribution.getValue(actions.size())];
	}
}