package anynt.space;


import graph.Edge;


/**
 * It extends an edge to represent ona connection between cells
 * 
 * @author Javier
 * @since 25/03/2001
 */
public class Connection extends Edge
{
	// Object attributes
	/**
	 * Action than permits to cross from the initial cell to the final cell
	 */
	private final int action;


	// Constructors
	public Connection(Cell startCell, Cell endCell, int action)
	{
		super(startCell, endCell);

		this.action = action;
	}

	// Treatment of object attributes
	public Cell getStartCell()
	{
		return (Cell) getStartVertex();
	}
	public Cell getEndCell()
	{
		return (Cell) getEndVertex();
	}
	public int getAction()
	{
		return action;
	}
}