package anynt.testEnvironments;


import java.util.Random;

import anynt.environment.Environment;
import anynt.object.Agent;
import anynt.space.Observation;
import anynt.space.SimpleObservation;


public class ChimpanzeeEnvironment extends Environment
{
	private String[] observations;
	private int actualObservation;


	public ChimpanzeeEnvironment()
	{
		super();

		actions = new int[4];
		actions[0] = 0;
		actions[1] = 1;
		actions[2] = 2;
		actions[3] = 3;

		observations = new String[4];
		observations[0] = "No observation";
		observations[1] = "Cell 1: Ball. Cell 2: No ball. Cell 3: No ball";
		observations[2] = "Cell 1: No ball. Cell 2: Ball. Cell 3: No ball";
		observations[3] = "Cell 1: No ball. Cell 2: No ball. Cell 3: Ball";
	}


	protected Observation takeObservation()
	{
		actualObservation = new Random().nextInt(observations.length - 1) + 1;
		return new SimpleObservation(observations[actualObservation]);
	}
	protected void prepareEnvironment()
	{
		
	}
	protected void prepareInteraction(int interactionNumber)
	{
		
	}
	protected void makeAction(Agent agent, int[] action)
	{
		agent.setReward(action[0] == actualObservation ? 1.0 : -1.0);
	}
	protected void actualize()
	{
		
	}
}