package graph;


/**
 * It represents an edge in graph theory
 * 
 * @author Javier
 * @since 25/03/2011
 */
public class Edge
{
	// Object attributes
	/**
	 * Origin vertex of the edge
	 */
	private final Vertex startVertex;
	/**
	 * Destiny vertex of the edge
	 */
	private final Vertex endVertex;


	// Constructors
	public Edge(Vertex startVertex, Vertex endVertex)
	{
		this.startVertex = startVertex;
		this.endVertex = endVertex;

		startVertex.addEdge(this);
		// If the edge is reflexive don't add it back
		if (!startVertex.equals(endVertex))
			endVertex.addEdge(this);
	}

	// Treatment of object attributes
	public Vertex getStartVertex()
	{
		return startVertex;
	}
	public Vertex getEndVertex()
	{
		return endVertex;
	}
}