package graph;


import java.util.Collection;


/**
 * Represents the interface of a graph in graph theory
 * 
 * @author Javier
 * @since 24/03/2011
 */
public interface IGraph
{
	// Treatment of object attributes
	Collection<Vertex> getVertices();
	Vertex getVertex(int identifier);
	void addVertex(Vertex vertex);
	void removeVertex(Vertex vertex);
	Collection<Edge> getEdges();
	void addEdge(Edge edge);
	void removeEdge(Edge edge);
	/**
	 * It returns the number of vertices of the graph
	 */
	int getOrder();

	// Object functions
	/**
	 * It checks if the graph is connected
	 */
	boolean isConnected();
	/**
	 * It checks if the graph is strongly connected
	 */
	boolean isStrongConnected();
}