package human.AGI;


import human.AGI.object.Agent;
import human.AGI.object.Cell;
import human.AGI.object.Rewards;
import interfaces.ExercisePanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import anynt.environment.LambdaEnvironment;
import anynt.exercise.Exercise;
import anynt.space.Space;

import java.awt.FlowLayout;


public class HumanAGIExercisePanel extends ExercisePanel
{
	private static final long serialVersionUID = 1L;


	public static final Color BACKGROUND_COLOR = Color.WHITE;


	private CellsPanel cellsPanel;
	//private JPanel rewardsBarPanel;
	private RewardsPanel rewardsPanel;

	private boolean firstPresentation;


//	private ArrayList<Cell> cells;
//	private ArrayList<Agent> agents;
	//private RewardsBar rewardsBar;
	private Rewards rewards;


	/**
	 * This is the default constructor
	 */
	public HumanAGIExercisePanel()
	{
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		setLayout(new BorderLayout());
		setPreferredSize(new Dimension(1000, 400));
		setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);

		cellsPanel = new CellsPanel();
		add(cellsPanel, BorderLayout.NORTH);
		/*this.rewardsBarPanel = new JPanel();
		this.rewardsBarPanel.setLayout(new FlowLayout(FlowLayout.CENTER, HumanEnvironmentPanel.CELL_SEPARATION, HumanEnvironmentPanel.CELL_SEPARATION));
		this.rewardsBarPanel.setBackground(HumanEnvironmentPanel.BACKGROUND_COLOR);
		this.add(this.rewardsBarPanel, BorderLayout.CENTER);*/
		rewardsPanel = new RewardsPanel();
		add(rewardsPanel, BorderLayout.CENTER);

		//this.rewardsBar = new RewardsBar(this.rewardsBarPanel);
		rewards = new Rewards(rewardsPanel);
	}


	public void setExercise(Exercise exercise)
	{
		super.setExercise(exercise);
		prepareExercise();
	}
	public Rewards getRewards()
	{
		return rewards;
	}


	protected void prepareExercise()
	{
		cellsPanel.setSpace(((LambdaEnvironment) exercise.getEnvironment()).getSpace());
//		ArrayList<anynt.space.Cell> cellsToRepresent = this.environment.GetSpace().GetCells();
//		int numberOfCells = this.environment.GetSpace().GetNumberOfCells();
//		this.cells = new ArrayList<Cell>();
//		// Assign colors the each cell
//		ArrayList<Color[]> colors = new ArrayList<Color[]>();
//		for (int i = 0; i < HumanEnvironmentPanel.MAX_COLORS; i++)
//			colors.add(HumanEnvironmentPanel.COLORS[i]);
//		for (int i = 0; i < numberOfCells; i++)
//		{
//			Cell cell = new Cell(cellsToRepresent.get(i));
//			int index = HumanEnvironmentPanel.random.nextInt(HumanEnvironmentPanel.MAX_COLORS - i);
//			cell.SetColor(colors.remove(index));
//			cell.SetSide(HumanEnvironmentPanel.SIDE);
//			this.cells.add(cell);
//		}

//		// Assign letter to each agent
//		this.subject = new Agent(this.environment.GetEvaluableAgent(), HumanEnvironmentPanel.SUBJECT_ICON);
//		//this.subject = new Agent(this.environment.GetEvaluableAgent(), HumanEnvironmentPanel.AGENT_ICON[this.agentIconIndex]);
//		//this.agentIconIndex = (this.agentIconIndex + 1) % HumanEnvironmentPanel.AGENT_ICONS_TO_USE;
//		this.good = new Agent(this.environment.GetGoodAgent(), HumanEnvironmentPanel.AGENT_GOOD_ICON[this.agentIconIndex]);
//		this.evil = new Agent(this.environment.GetEvilAgent(), HumanEnvironmentPanel.AGENT_EVIL_ICON[this.agentIconIndex]);
//		this.agentIconIndex = (this.agentIconIndex + 1) % HumanEnvironmentPanel.AGENT_ICONS_TO_USE;
//
//		this.agents = new ArrayList<Agent>();
//		this.agents.add(this.subject);
//		this.agents.add(this.good);
//		this.agents.add(this.evil);

		cellsPanel.prepare(exercise);

		firstPresentation = true;
	}

	protected void clear()
	{
//		this.cellsPanel.Clear();
		//this.rewardsBarPanel.removeAll();
		rewardsPanel.removeAll();
	}
	protected void draw()
	{
		invalidate();
		clear();

		drawCells();
		if (!firstPresentation)
			drawRewards();
		else
			firstPresentation = false;

		repaint();
		revalidate();
	}

	// Draws all the cells
	private void drawCells()
	{
		cellsPanel.update();

		cellsPanel.draw();
	}
	private void drawRewards()
	{
		updateRewards();

		//this.rewardsBar.Draw();
		rewards.draw();
	}

//	private void UpdateCell(Cell cell)
//	{
//		cell.ClearAgents();
//		anynt.space.Cell cellToRepresent = cell.GetCell();
//		for (Agent agent : this.agents)
//		{
//			anynt.object.Agent agentToRepresent = agent.GetAgent();
//			if (cellToRepresent.GetAgents().contains(agentToRepresent))
//				cell.AddAgent(agent);
//		}
//		anynt.space.Cell subjectCell = this.environment.GetEvaluableAgent().GetLocation();
//		ArrayList<anynt.space.Cell> subjectConnectedCell = subjectCell.GetConnectedCells();
//		if (subjectConnectedCell.contains(cell.GetCell()))
//		{
//			cell.SetConnected(true);
//			for (Integer action : subjectCell.GetAvailableActions())
//				if (subjectCell.Move(action).GetNumber() == cellToRepresent.GetNumber())
//				{
//					cell.SetAction(action);
//					break;
//				}
//		}
//		else
//		{
//			cell.SetConnected(false);
//			cell.SetAction(0);
//		}
//	}
	private void updateRewards()
	{
		//this.rewardsBar.SetReward(this.environment.GetEvaluableAgent().LastReward());
		rewards.setReward(exercise.getEvaluableAgent().lastReward());
	}

	public void notifyObserver()
	{
		draw();
	}
}


class CellsPanel extends JPanel
{
	private static final long serialVersionUID = 1L;

	private static final long SEED = 1;

	private static Random random;

	public static final int CELL_SIDE = 100;
	public static final int CELL_SEPARATION = 15;
	private static final int MAX_COLORS = 9;
	private static Color[][] COLORS;
	private static ImageIcon SUBJECT_ICON;
	private static ImageIcon[] AGENT_GOOD_ICON;
	private static ImageIcon[] AGENT_EVIL_ICON;
	private static final int AGENT_ICONS_TO_USE = 7;

	private static final int ICON_SIDE = 25;
	private int agentIconIndex;


	private ArrayList<Cell> cells;
	private ArrayList<Agent> agents;
	//private Space space;

	private Agent subject;
	private Agent good;
	private Agent evil;


	public CellsPanel()
	{
		super();
		initialize();

		cells = new ArrayList<Cell>();
	}
	private void initialize()
	{
		CellsPanel.random = new Random();
		CellsPanel.random.setSeed(CellsPanel.SEED);

		setLayout(new FlowLayout(FlowLayout.CENTER, CellsPanel.CELL_SEPARATION, CellsPanel.CELL_SEPARATION));
		setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);

		initializeColors();
		initializeAgentsIcons();

		agentIconIndex = 0;
	}
	private void initializeColors()
	{
		CellsPanel.COLORS = new Color[CellsPanel.MAX_COLORS][2];

		CellsPanel.COLORS[0][0] = new Color(200, 255, 250);
		CellsPanel.COLORS[0][1] = new Color(100, 250, 250);
		CellsPanel.COLORS[1][0] = new Color(250, 200, 250);
		CellsPanel.COLORS[1][1] = new Color(250, 100, 250);
		CellsPanel.COLORS[2][0] = new Color(250, 250, 200);
		CellsPanel.COLORS[2][1] = new Color(250, 250, 100);
		CellsPanel.COLORS[3][0] = new Color(200, 200, 250);
		CellsPanel.COLORS[3][1] = new Color(100, 100, 250);
		CellsPanel.COLORS[4][0] = new Color(200, 175, 150);
		CellsPanel.COLORS[4][1] = new Color(200, 100, 0);
		CellsPanel.COLORS[5][0] = new Color(200, 250, 200);
		CellsPanel.COLORS[5][1] = new Color(100, 250, 100);
		CellsPanel.COLORS[6][0] = new Color(250, 200, 150);
		CellsPanel.COLORS[6][1] = new Color(250, 100, 0);
		CellsPanel.COLORS[7][0] = new Color(175, 225, 200);
		CellsPanel.COLORS[7][1] = new Color(0, 200, 150);
		CellsPanel.COLORS[8][0] = new Color(250, 175, 175);
		CellsPanel.COLORS[8][1] = new Color(250, 100, 100);
	}
	private void initializeAgentsIcons()
	{
		CellsPanel.AGENT_GOOD_ICON = new ImageIcon[CellsPanel.AGENT_ICONS_TO_USE];
		CellsPanel.AGENT_EVIL_ICON = new ImageIcon[CellsPanel.AGENT_ICONS_TO_USE];
		CellsPanel.SUBJECT_ICON = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/agent.png")).getImage().getScaledInstance(CellsPanel.ICON_SIDE, CellsPanel.ICON_SIDE, Image.SCALE_SMOOTH));
		for (int i = 0; i < CellsPanel.AGENT_ICONS_TO_USE; i++)
		{
			CellsPanel.AGENT_GOOD_ICON[i] = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/good" + (i + 1) + ".png")).getImage().getScaledInstance(CellsPanel.ICON_SIDE, CellsPanel.ICON_SIDE, Image.SCALE_SMOOTH));
			CellsPanel.AGENT_EVIL_ICON[i] = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/evil" + (i + 1) + ".png")).getImage().getScaledInstance(CellsPanel.ICON_SIDE, CellsPanel.ICON_SIDE, Image.SCALE_SMOOTH));
		}
	}


	public void setSpace(Space space)
	{
		//this.space = space;

		removeAll();
		cells.clear();
		cells = new ArrayList<Cell>();
		// Assign colors the each cell
		ArrayList<Color[]> colors = new ArrayList<Color[]>();
		for (int i = 0; i < CellsPanel.MAX_COLORS; i++)
			colors.add(CellsPanel.COLORS[i]);

		int i = 0;
		for (anynt.space.Cell cellToRepresent : space.getCells())
		{
			Cell cell = new Cell(cellToRepresent);
			int index = CellsPanel.random.nextInt(CellsPanel.MAX_COLORS - i);
			cell.setColor(colors.remove(index));
			cell.setSide(CellsPanel.CELL_SIDE);
			cells.add(cell);

			add(cell);
			i++;
		}
	}
	public void prepare(Exercise exercise)
	{
		// Assign letter to each agent
		subject = new Agent(exercise.getEvaluableAgent(), CellsPanel.SUBJECT_ICON);
		//this.subject = new Agent(this.environment.GetEvaluableAgent(), HumanEnvironmentPanel.AGENT_ICON[this.agentIconIndex]);
		//this.agentIconIndex = (this.agentIconIndex + 1) % HumanEnvironmentPanel.AGENT_ICONS_TO_USE;
		good = new Agent(((LambdaEnvironment) exercise.getEnvironment()).getGoodAgent(), CellsPanel.AGENT_GOOD_ICON[agentIconIndex]);
		evil = new Agent(((LambdaEnvironment) exercise.getEnvironment()).getEvilAgent(), CellsPanel.AGENT_EVIL_ICON[agentIconIndex]);
		agentIconIndex = (agentIconIndex + 1) % CellsPanel.AGENT_ICONS_TO_USE;

		agents = new ArrayList<Agent>();
		agents.add(subject);
		agents.add(good);
		agents.add(evil);
	}
	public void clear()
	{
		cells.clear();
	}


	public void update()
	{
		for (Cell cell : cells)
		{
			cell.clearAgents();
			anynt.space.Cell cellToRepresent = cell.getCell();
			for (Agent agent : agents)
			{
				anynt.object.Agent agentToRepresent = agent.getAgent();
				if (cellToRepresent.getAgents().contains(agentToRepresent))
					cell.addAgent(agent);
			}
			anynt.space.Cell subjectCell = subject.getAgent().getLocation();
			Collection<anynt.space.Cell> subjectConnectedCell = subjectCell.getConnectedCells();
			if (subjectConnectedCell.contains(cell.getCell()))
			{
				cell.setConnected(true);
				for (Integer action : subjectCell.getAvailableActions())
					if (subjectCell.destinationCell(action).equals(cellToRepresent))
					{
						cell.setAction(action);
						break;
					}
			}
			else
			{
				cell.setConnected(false);
				cell.setAction(0);
			}
		}
	}
	public void draw()
	{
		for (Cell cell : cells)
			cell.draw();
	}
}


class RewardsPanel extends JPanel
{
	private static final long serialVersionUID = 1L;


	public RewardsPanel()
	{
		setLayout(new FlowLayout(FlowLayout.CENTER));
		setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);
	}
}