package human.AGI;


import interfaces.HumanAGITestInterface;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextArea;


public class StartExercisePanel extends JPanel {

	private static final long serialVersionUID = 1L;


	private HumanAGITestInterface frame;

	private JTextArea infoArea;
	private JButton continueButton;

	private int exercise;


	/**
	 * This is the default constructor
	 */
	public StartExercisePanel(HumanAGITestInterface frame, int exercise) {
		super();
		this.exercise = exercise;
		initialize();

		this.frame = frame;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setSize(500, 300);
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 0;
		add(getInfoArea(), c);
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 0;
		c.gridy = 1;
		c.insets = new Insets(20, 0, 0, 0);  
		add(getContinueButton(), c);
		//this.setBackground(Color.WHITE);
	}


	/**
	 * This method initializes infoArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getInfoArea() {
		if (infoArea == null) {
			infoArea = new JTextArea();
			infoArea.setEditable(false);
			infoArea.setPreferredSize(new Dimension(460, 200));
			infoArea.setMargin(new Insets(10, 10, 10, 10));
			infoArea.setLineWrap(true);
			String texto = "EXERCISE " + exercise + "\n\n";
			if (exercise == 1)
				texto += "     This is the first exercise.\n";
			else
				texto += "     This is a new exercise.\n";
			texto += "     Remember that speed is not measured by the test.\n     Take your time and do not act hastily.\n     Remember that your goal is to obtain as more positive rewards as possible        and as few negative rewards as possible.";
			infoArea.setText(texto);
			infoArea.setBackground(getBackground());
		}
		return infoArea;
	}

	/**
	 * This method initializes continueButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getContinueButton() {
		if (continueButton == null) {
			continueButton = new JButton("Go to exercise");
			continueButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					goToExercise();
				}
			});
		}
		return continueButton;
	}


	private void goToExercise()
	{
		frame.launchExercisePanel();
	}
}