package human.AGI.object;


import java.awt.Container;
import java.awt.Dimension;
import java.awt.Image;

import javax.swing.ImageIcon;
import javax.swing.JLabel;


public class Rewards implements Runnable
{
	private static int SEGUNDOS_A_ESPERAR = 3;
	private static int ANCHO_IMAGEN = 100;
	private static int ALTO_IMAGEN = 100;

	private static ImageIcon NEUTRAL_REWARD_ICON;
	private static ImageIcon POSITIVE_REWARD_ICON;
	private static ImageIcon NEGATIVE_REWARD_ICON;


	private Thread thread;

	private Container parent;
	private double reward;
	private JLabel image;


	public Rewards(Container parent)
	{
		this.parent = parent;

		Rewards.NEUTRAL_REWARD_ICON = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/neutral_reward.png")).getImage().getScaledInstance(Rewards.ANCHO_IMAGEN, Rewards.ALTO_IMAGEN, Image.SCALE_SMOOTH));
		Rewards.POSITIVE_REWARD_ICON = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/pos_reward.png")).getImage().getScaledInstance(Rewards.ANCHO_IMAGEN, Rewards.ALTO_IMAGEN, Image.SCALE_SMOOTH));
		Rewards.NEGATIVE_REWARD_ICON = new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/neg_reward.png")).getImage().getScaledInstance(Rewards.ANCHO_IMAGEN, Rewards.ALTO_IMAGEN, Image.SCALE_SMOOTH));

		reward = 0.0;
		image = new JLabel();
		image.setPreferredSize(new Dimension(Rewards.ANCHO_IMAGEN, Rewards.ALTO_IMAGEN));
	}


	public void setReward(double reward)
	{
		this.reward = reward;
	}


	public void run()
	{
		try
		{
			synchronized (this)
			{
				wait(Rewards.SEGUNDOS_A_ESPERAR * 1000);
			}
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
		finally
		{
			clear();
		}
	}


	public void draw()
	{
		drawImage();

		try
		{
			if (thread != null && thread.isAlive())
			{
				thread.notify();
				thread.join();
			}
			thread = new Thread(this);
			thread.start();
		}
		catch (Exception e)
		{
			
		}
	}


	private void clear()
	{
		image.setIcon(null);
		parent.remove(image);
		parent.repaint();
	}
	private void drawImage()
	{
		ImageIcon imagen = null;

		if (reward > 0.0)
			imagen = Rewards.POSITIVE_REWARD_ICON;
		else if (reward < 0.0)
			imagen = Rewards.NEGATIVE_REWARD_ICON;
		else
			imagen = Rewards.NEUTRAL_REWARD_ICON;

		image.setIcon(imagen);
		parent.add(image);
		parent.repaint();
	}
}