package human.AGI.object;


import human.AGI.HumanAGIExercisePanel;

import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JPanel;
import javax.swing.JProgressBar;


public class RewardsBar
{
	private static int SEGUNDOS_A_ESPERAR = 3;
	private static int HEIGHT = 25;
	private static int WIDTH = 200;


	private Container parent;
	private JPanel bar;
	private JProgressBar negativeBar;
	private JProgressBar positiveBar;


	public RewardsBar(Container parent)
	{
		this.parent = parent;

		bar = new JPanel();
		bar.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
		bar.setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);

		negativeBar = new JProgressBar();
		negativeBar.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		negativeBar.setPreferredSize(new Dimension(RewardsBar.WIDTH, RewardsBar.HEIGHT));
		negativeBar.setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);
		negativeBar.setForeground(Color.RED);

		positiveBar = new JProgressBar();
		positiveBar.setPreferredSize(new Dimension(RewardsBar.WIDTH, RewardsBar.HEIGHT));
		positiveBar.setBackground(HumanAGIExercisePanel.BACKGROUND_COLOR);
		positiveBar.setForeground(Color.GREEN);

		bar.add(negativeBar);
		bar.add(positiveBar);
	}


	public void setReward(double averageReward)
	{
		negativeBar.setValue((int) -(averageReward * 100));
		positiveBar.setValue((int) (averageReward * 100));
	}


	public void draw()
	{
		try
		{
			drawImage();
			synchronized (this)
			{
				wait(RewardsBar.SEGUNDOS_A_ESPERAR * 1000);
			}
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
		finally
		{
			clear();
		}
	}


	private void clear()
	{
		parent.remove(bar);
	}
	private void drawImage()
	{
		parent.add(bar);
		parent.repaint();
	}
}