package interfaces;


import human.AGI.HumanAGIExercisePanel;
import human.AGI.InstructionsPanel;
import human.AGI.ResultsPanel;
import human.AGI.StartExercisePanel;
import anynt.exercise.Exercise;
import anynt.object.EvaluableAgent;
import anynt.object.behaviour.HumanBehaviour;
import anynt.object.moveController.NumberOfMovementsMoveController;
import anynt.test.AGITest;


@SuppressWarnings("serial")
public class HumanAGITestInterface extends TestInterface
{
	public HumanAGITestInterface()
	{
		exercisePanel = new HumanAGIExercisePanel();

		test = AGITest.getTest();
		EvaluableAgent agent = new EvaluableAgent("Human");
		agent.setMoveController(new NumberOfMovementsMoveController());
		agent.setBehaviour(new HumanBehaviour());
		Exercise exercise = new Exercise();
		exercise.setEvaluableAgent(agent);
		test.setExercise(exercise);
	}
	public static void main(String args[])
	{
		new HumanAGITestInterface().launch();
	}


	@SuppressWarnings("deprecation")
	public void launch()
	{
		setSize(WIDTH, HEIGHT);
		setTitle("Anytime Universal Intelligence - Human Interface");
		setResizable(false);
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		show();
		setContentPanel(new InstructionsPanel(this));
	}


	public void launchTest(String name)
	{
		((AGITest) test).setSubjectName(name);
		((AGITest) test).setFrame(this);
		test.start();
	}
	public synchronized void launchExercise()
	{
		setContentPanel(new StartExercisePanel(this, test.getExerciseNumber()));
	}
	public void launchExercisePanel()
	{
		exercisePanel.setExercise(test.getExercise());
		setContentPanel(exercisePanel);
		synchronized (test)
		{
			test.notify();
		}
	}
	public void showResults()
	{
		long takenTime = ((AGITest) test).getTakenTime();
		setContentPanel(new ResultsPanel(takenTime));
	}
}