package investigation;


import interfaces.InvestigationTestInterface;
import javax.swing.JPanel;
import java.awt.Rectangle;
import java.awt.Dimension;

import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import java.awt.Color;
import java.awt.Point;
import javax.swing.JTextPane;
import javax.swing.JLabel;
import javax.swing.JButton;

import anynt.environment.LambdaEnvironment;
import anynt.environment.settings.NoShareRewards;
import anynt.environment.settings.RewardsProvider;
import anynt.environment.settings.ShareRewardsBetweenEvaluableAgents;
import anynt.exercise.Exercise;
import anynt.exercise.settings.InteractionType;
import anynt.exercise.settings.NumberOfInteractionsInteractionType;
import anynt.exercise.settings.StepByStepWaiting;
import anynt.exercise.settings.StepWaiting;
import anynt.exercise.settings.TimeDelayWaiting;
import anynt.exercise.settings.TimeLimitInteractionType;
import anynt.object.EvaluableAgent;
import anynt.object.RewardsGeneratorAgent;
import anynt.object.behaviour.AgentBehaviour;
import anynt.object.behaviour.HumanBehaviour;
import anynt.object.behaviour.OracleBehaviour;
import anynt.object.behaviour.QLearningBehaviour;
import anynt.object.behaviour.RandomBehaviour;
import anynt.object.behaviour.TrivialFollowerBehaviour;
import anynt.object.moveController.IAgentMoveController;
import anynt.object.moveController.NumberOfMovementsMoveController;


@SuppressWarnings("serial")
public class ExerciseOptionsPanel extends JPanel
{
	private InvestigationTestInterface frame;
	private Exercise exercise;


	private JPanel evaluableAgent = null;
	private JRadioButton humanAgent = null;
	private JRadioButton trivialFollowerAgent = null;
	private JRadioButton randomAgent = null;
	private JPanel interactionType = null;
	private JRadioButton interactions = null;
	private JRadioButton timeLimit = null;
	private JTextPane numberIntractionsPane = null;
	private JTextPane timeLimitPane = null;
	private JPanel steps = null;
	private JRadioButton changeStepsManually = null;
	private JRadioButton timeDelay = null;
	private JTextPane timeDelayPane = null;
	private JLabel secondsTimeLimit = null;
	private JLabel secondsTimeDelay = null;
	private JPanel rewardConsumptionOptions = null;
	private JLabel rewardConsumptionOrderLabel = null;
	private JRadioButton beforeUpdate = null;
	private JRadioButton afterUpdate = null;
	private JLabel decreaseFactorLabel = null;
	private JRadioButton numberRewardDecrease = null;
	private JRadioButton infiniteDecreaseFactor = null;
	private JTextPane factorDecreaseValuePane = null;
	private JLabel rewardsConsumedLabel = null;
	private JRadioButton consumeRewardsYes = null;
	private JRadioButton consumeRewardsNo = null;
	private JLabel rewardsShared = null;
	private JRadioButton shareRewardsYes = null;
	private JRadioButton shareRewardsNo = null;
	private JButton agree = null;
	private JLabel agreement = null;


	private JRadioButton oracleAgent = null;

	private JRadioButton qLearningAgent = null;

	private JPanel qLearningParameters = null;

	private JLabel alfaLabel = null;

	private JLabel gammaLabel = null;

	private JTextPane alfaValue = null;

	private JTextPane gammaValue = null;

	private JLabel betaLabel = null;

	private JTextPane betaValue = null;

	private JLabel qInitialLabel = null;

	private JTextPane qInitialValue = null;
	/**
	 * This is the default constructor
	 */
	public ExerciseOptionsPanel(InvestigationTestInterface frame, Exercise exercise)
	{
		super();

		this.frame = frame;
		this.exercise = exercise;

		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		agreement = new JLabel();
		agreement.setBounds(new Rectangle(206, 536, 226, 16));
		agreement.setText("Do you agree with the session options?");
		setSize(705, 660);
		setLayout(null);
		add(getEvaluableAgent(), null);
		add(getInteractionType(), null);
		add(getSteps(), null);
		add(getRewardConsumptionOptions(), null);
		add(getAgree(), null);
		add(agreement, null);
		add(getQLearningParameters(), null);

		randomAgent.doClick();
	}

	/**
	 * This method initializes evaluableAgent	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getEvaluableAgent() {
		if (evaluableAgent == null) {
			evaluableAgent = new JPanel();
			evaluableAgent.setLayout(null);
			evaluableAgent.setBounds(new Rectangle(5, 5, 492, 60));
			evaluableAgent.setBorder(BorderFactory.createTitledBorder(null, "Evaluable Agent", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			evaluableAgent.add(getHumanAgent(), null);
			evaluableAgent.add(getTrivialFollowerAgent(), null);
			evaluableAgent.add(getRandomAgent(), null);
			evaluableAgent.add(getOracleAgent(), null);
			evaluableAgent.add(getQLearningAgent(), null);

			ButtonGroup agents = new ButtonGroup();
			agents.add(getHumanAgent());
			agents.add(getTrivialFollowerAgent());
			agents.add(getRandomAgent());
			agents.add(getOracleAgent());
			agents.add(getQLearningAgent());
		}
		return evaluableAgent;
	}

	/**
	 * This method initializes humanAgent	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getHumanAgent() {
		if (humanAgent == null) {
			humanAgent = new JRadioButton();
			humanAgent.setBounds(new Rectangle(15, 25, 70, 20));
			humanAgent.setText("Human");
			humanAgent.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectedHumanAgent();
				}
			});
		}
		return humanAgent;
	}

	/**
	 * This method initializes trivialFollowerAgent	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getTrivialFollowerAgent() {
		if (trivialFollowerAgent == null) {
			trivialFollowerAgent = new JRadioButton();
			trivialFollowerAgent.setBounds(new Rectangle(90, 25, 120, 20));
			trivialFollowerAgent.setName("");
			trivialFollowerAgent.setText("Trivial Follower");
			trivialFollowerAgent.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectedTrivialFollowerAgent();
				}
			});
		}
		return trivialFollowerAgent;
	}

	/**
	 * This method initializes randomAgent	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRandomAgent() {
		if (randomAgent == null) {
			randomAgent = new JRadioButton();
			randomAgent.setBounds(new Rectangle(210, 25, 75, 20));
			randomAgent.setSelected(true);
			randomAgent.setText("Random");
			randomAgent.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectedRandomAgent();
				}
			});
		}
		return randomAgent;
	}

	/**
	 * This method initializes interactionType	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getInteractionType() {
		if (interactionType == null) {
			TitledBorder titledBorder = BorderFactory.createTitledBorder(null, "Interaction Type", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51));
			titledBorder.setTitle("Session Stop");
			secondsTimeLimit = new JLabel();
			secondsTimeLimit.setText("seconds");
			secondsTimeLimit.setBounds(new Rectangle(160, 50, 50, 20));
			secondsTimeLimit.setEnabled(false);
			interactionType = new JPanel();
			interactionType.setLayout(null);
			interactionType.setBounds(new Rectangle(5, 207, 298, 92));
			interactionType.setBorder(titledBorder);
			interactionType.add(getInteractions(), null);
			interactionType.add(getTimeLimit(), null);
			interactionType.add(getNumberIntractionsPane(), null);
			interactionType.add(getTimeLimitPane(), null);
			interactionType.add(secondsTimeLimit, null);

			ButtonGroup interactions = new ButtonGroup();
			interactions.add(getInteractions());
			interactions.add(getTimeLimit());
		}
		return interactionType;
	}

	/**
	 * This method initializes interactions	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getInteractions() {
		if (interactions == null) {
			interactions = new JRadioButton();
			interactions.setText("No. of steps");
			interactions.setSelected(true);
			interactions.setBounds(new Rectangle(15, 25, 95, 20));
			interactions.setFont(new Font("Dialog", Font.BOLD, 12));
			interactions.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					timeLimitPane.setEnabled(false);
					numberIntractionsPane.setEnabled(true);
					secondsTimeLimit.setEnabled(false);
					timeLimitPane.setBackground(Color.LIGHT_GRAY);
					numberIntractionsPane.setBackground(Color.WHITE);

					checkAgreeEnabled();
				}
			});
		}
		return interactions;
	}

	/**
	 * This method initializes timeLimit	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getTimeLimit() {
		if (timeLimit == null) {
			timeLimit = new JRadioButton();
			timeLimit.setText("Time Limit");
			timeLimit.setBounds(new Rectangle(15, 50, 85, 20));
			timeLimit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					timeLimitPane.setEnabled(true);
					numberIntractionsPane.setEnabled(false);
					secondsTimeLimit.setEnabled(true);
					timeLimitPane.setBackground(Color.WHITE);
					numberIntractionsPane.setBackground(Color.LIGHT_GRAY);

					checkAgreeEnabled();
				}
			});
		}
		return timeLimit;
	}

	/**
	 * This method initializes numberIntractionsPane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getNumberIntractionsPane() {
		if (numberIntractionsPane == null) {
			numberIntractionsPane = new JTextPane();
			numberIntractionsPane.setText("1000");
			numberIntractionsPane.setBounds(new Rectangle(125, 25, 70, 20));
			numberIntractionsPane.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			numberIntractionsPane.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return numberIntractionsPane;
	}

	/**
	 * This method initializes timeLimitPane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getTimeLimitPane() {
		if (timeLimitPane == null) {
			timeLimitPane = new JTextPane();
			timeLimitPane.setText("10");
			timeLimitPane.setEnabled(false);
			timeLimitPane.setBackground(Color.lightGray);
			timeLimitPane.setBounds(new Rectangle(115, 50, 40, 20));
			timeLimitPane.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			timeLimitPane.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return timeLimitPane;
	}

	/**
	 * This method initializes steps	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSteps() {
		if (steps == null) {
			secondsTimeDelay = new JLabel();
			secondsTimeDelay.setText("seconds");
			secondsTimeDelay.setLocation(new Point(165, 50));
			secondsTimeDelay.setSize(new Dimension(49, 16));
			secondsTimeDelay.setEnabled(false);
			steps = new JPanel();
			steps.setLayout(null);
			steps.setBorder(BorderFactory.createTitledBorder(null, "Steps", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			steps.setSize(new Dimension(256, 80));
			steps.setLocation(new Point(314, 207));
			steps.add(getChangeStepsManually(), null);
			steps.add(getTimeDelay(), null);
			steps.add(getTimeDelayPane(), null);
			steps.add(secondsTimeDelay, null);

			ButtonGroup stepsType = new ButtonGroup();
			stepsType.add(getChangeStepsManually());
			stepsType.add(getTimeDelay());
		}
		return steps;
	}

	/**
	 * This method initializes timeDelay	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getTimeDelay() {
		if (timeDelay == null) {
			timeDelay = new JRadioButton();
			timeDelay.setText("Time Delay");
			timeDelay.setLocation(new Point(15, 50));
			timeDelay.setSize(new Dimension(92, 21));
			timeDelay.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					timeDelayPane.setEnabled(true);
					secondsTimeDelay.setEnabled(true);
					timeDelayPane.setBackground(Color.WHITE);

					checkAgreeEnabled();
				}
			});
		}
		return timeDelay;
	}

	/**
	 * This method initializes changeStepsManually	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getChangeStepsManually() {
		if (changeStepsManually == null) {
			changeStepsManually = new JRadioButton();
			changeStepsManually.setSize(new Dimension(157, 21));
			changeStepsManually.setText("Step by Step Manually");
			changeStepsManually.setSelected(true);
			changeStepsManually.setLocation(new Point(15, 24));
			changeStepsManually.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					timeDelayPane.setEnabled(false);
					secondsTimeDelay.setEnabled(false);
					timeDelayPane.setBackground(Color.LIGHT_GRAY);

					checkAgreeEnabled();
				}
			});
		}
		return changeStepsManually;
	}

	/**
	 * This method initializes timeDelayPane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getTimeDelayPane() {
		if (timeDelayPane == null) {
			timeDelayPane = new JTextPane();
			timeDelayPane.setEnabled(false);
			timeDelayPane.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			timeDelayPane.setLocation(new Point(114, 48));
			timeDelayPane.setText("0");
			timeDelayPane.setSize(new Dimension(43, 22));
			timeDelayPane.setBackground(Color.lightGray);
			timeDelayPane.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return timeDelayPane;
	}

	/**
	 * This method initializes rewardConsumptionOptions	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getRewardConsumptionOptions() {
		if (rewardConsumptionOptions == null) {
			rewardConsumptionOrderLabel = new JLabel();
			rewardConsumptionOrderLabel.setText("Reward Consumption Order");
			rewardConsumptionOrderLabel.setBounds(new Rectangle(15, 30, 168, 16));
			rewardsShared = new JLabel();
			rewardsShared.setText("Are cell rewards shared by several evaluable agents sharing the same cell?");
			rewardsShared.setLocation(new Point(15, 167));
			rewardsShared.setSize(new Dimension(436, 16));
			rewardsConsumedLabel = new JLabel();
			rewardsConsumedLabel.setText("Are cell rewards consumed by evaluable agents?");
			rewardsConsumedLabel.setLocation(new Point(15, 112));
			rewardsConsumedLabel.setSize(new Dimension(281, 16));
			decreaseFactorLabel = new JLabel();
			decreaseFactorLabel.setText("Cell reward decreasing factor");
			decreaseFactorLabel.setLocation(new Point(346, 32));
			decreaseFactorLabel.setSize(new Dimension(174, 16));
			rewardConsumptionOptions = new JPanel();
			rewardConsumptionOptions.setLayout(null);
			rewardConsumptionOptions.setBorder(BorderFactory.createTitledBorder(null, "Reward Consumption Options", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			rewardConsumptionOptions.setSize(new Dimension(660, 225));
			rewardConsumptionOptions.setLocation(new Point(5, 306));
			rewardConsumptionOptions.add(getBeforeUpdate(), null);
			rewardConsumptionOptions.add(getAfterUpdate(), null);

			rewardConsumptionOptions.add(getNumberRewardDecrease(), null);
			rewardConsumptionOptions.add(getInfiniteDecreaseFactor(), null);

			rewardConsumptionOptions.add(getFactorDecreaseValuePane(), null);
			rewardConsumptionOptions.add(getConsumeRewardsYes(), null);
			rewardConsumptionOptions.add(getConsumeRewardsNo(), null);

			rewardConsumptionOptions.add(getShareRewardsYes(), null);
			rewardConsumptionOptions.add(getShareRewardsNo(), null);

			ButtonGroup rewardConsumptionOrder = new ButtonGroup();
			rewardConsumptionOrder.add(getBeforeUpdate());
			rewardConsumptionOrder.add(getAfterUpdate());
			ButtonGroup decreaseFactor = new ButtonGroup();
			decreaseFactor.add(getNumberRewardDecrease());
			decreaseFactor.add(getInfiniteDecreaseFactor());
			ButtonGroup consumeRewards = new ButtonGroup();
			consumeRewards.add(consumeRewardsYes);
			consumeRewards.add(consumeRewardsNo);
			ButtonGroup shareRewards = new ButtonGroup();
			shareRewards.add(shareRewardsYes);
			shareRewards.add(shareRewardsNo);

			rewardConsumptionOptions.add(decreaseFactorLabel, null);
			rewardConsumptionOptions.add(rewardsConsumedLabel, null);
			rewardConsumptionOptions.add(rewardsShared, null);
			rewardConsumptionOptions.add(rewardConsumptionOrderLabel, null);
		}
		return rewardConsumptionOptions;
	}

	/**
	 * This method initializes BeforeUpdate	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getBeforeUpdate() {
		if (beforeUpdate == null) {
			beforeUpdate = new JRadioButton();
			beforeUpdate.setText("Before the rewarders update the cell reward");
			beforeUpdate.setBounds(new Rectangle(15, 50, 281, 21));
			beforeUpdate.setSelected(true);
		}
		return beforeUpdate;
	}

	/**
	 * This method initializes AfterUpdate	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getAfterUpdate() {
		if (afterUpdate == null) {
			afterUpdate = new JRadioButton();
			afterUpdate.setText("Just after the rewarders update the cell reward");
			afterUpdate.setLocation(new Point(15, 75));
			afterUpdate.setSize(new Dimension(298, 21));
		}
		return afterUpdate;
	}

	/**
	 * This method initializes numberRewardDecrease	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getNumberRewardDecrease() {
		if (numberRewardDecrease == null) {
			numberRewardDecrease = new JRadioButton();
			numberRewardDecrease.setSize(new Dimension(142, 21));
			numberRewardDecrease.setText("Set decrease factor");
			numberRewardDecrease.setSelected(true);
			numberRewardDecrease.setLocation(new Point(346, 52));
			numberRewardDecrease.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					factorDecreaseValuePane.setEnabled(true);
					factorDecreaseValuePane.setBackground(Color.WHITE);

					checkAgreeEnabled();
				}
			});
		}
		return numberRewardDecrease;
	}

	/**
	 * This method initializes infiniteDecreaseFactor	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getInfiniteDecreaseFactor() {
		if (infiniteDecreaseFactor == null) {
			infiniteDecreaseFactor = new JRadioButton();
			infiniteDecreaseFactor.setSize(new Dimension(295, 21));
			infiniteDecreaseFactor.setText("Infinite (so rewards are set to 0 after each step)");
			infiniteDecreaseFactor.setLocation(new Point(346, 78));
			infiniteDecreaseFactor.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					factorDecreaseValuePane.setEnabled(false);
					factorDecreaseValuePane.setBackground(Color.LIGHT_GRAY);

					checkAgreeEnabled();
				}
			});
		}
		return infiniteDecreaseFactor;
	}

	/**
	 * This method initializes factorDecreaseValuePane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getFactorDecreaseValuePane() {
		if (factorDecreaseValuePane == null) {
			factorDecreaseValuePane = new JTextPane();
			factorDecreaseValuePane.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			factorDecreaseValuePane.setBounds(new Rectangle(491, 52, 40, 22));
			factorDecreaseValuePane.setText("2");
			factorDecreaseValuePane.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return factorDecreaseValuePane;
	}

	/**
	 * This method initializes consumeRewardsYes	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getConsumeRewardsYes() {
		if (consumeRewardsYes == null) {
			consumeRewardsYes = new JRadioButton();
			consumeRewardsYes.setText("Yes");
			consumeRewardsYes.setLocation(new Point(15, 132));
			consumeRewardsYes.setSelected(true);
			consumeRewardsYes.setSize(new Dimension(51, 21));
		}
		return consumeRewardsYes;
	}

	/**
	 * This method initializes consumeRewardsNo	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getConsumeRewardsNo() {
		if (consumeRewardsNo == null) {
			consumeRewardsNo = new JRadioButton();
			consumeRewardsNo.setText("No");
			consumeRewardsNo.setLocation(new Point(72, 132));
			consumeRewardsNo.setSize(new Dimension(49, 21));
		}
		return consumeRewardsNo;
	}

	/**
	 * This method initializes shareRewardsYes	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getShareRewardsYes() {
		if (shareRewardsYes == null) {
			shareRewardsYes = new JRadioButton();
			shareRewardsYes.setText("Yes");
			shareRewardsYes.setLocation(new Point(15, 187));
			shareRewardsYes.setSize(new Dimension(49, 21));
		}
		return shareRewardsYes;
	}

	/**
	 * This method initializes shareRewardsNo	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getShareRewardsNo() {
		if (shareRewardsNo == null) {
			shareRewardsNo = new JRadioButton();
			shareRewardsNo.setText("No");
			shareRewardsNo.setLocation(new Point(72, 187));
			shareRewardsNo.setSelected(true);
			shareRewardsNo.setSize(new Dimension(43, 21));
		}
		return shareRewardsNo;
	}

	/**
	 * This method initializes agree	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAgree() {
		if (agree == null) {
			agree = new JButton();
			agree.setText("Agree");
			agree.setLocation(new Point(266, 560));
			agree.setSize(new Dimension(99, 32));
			agree.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// Agent
					LambdaEnvironment environment = (LambdaEnvironment) exercise.getEnvironment();
					EvaluableAgent agent = exercise.getEvaluableAgent();
					IAgentMoveController moveController = new NumberOfMovementsMoveController();
					AgentBehaviour behaviour = null;
					if (humanAgent.isSelected())
						behaviour = new HumanBehaviour();
					else if (trivialFollowerAgent.isSelected())
					{
						RewardsGeneratorAgent good = environment.getGoodAgent();
						RewardsGeneratorAgent evil = environment.getEvilAgent();
						behaviour = new TrivialFollowerBehaviour(good, evil);
					}
					else if (randomAgent.isSelected())
						behaviour = new RandomBehaviour();
					else if (oracleAgent.isSelected())
						behaviour = new OracleBehaviour(environment);
					else if (qLearningAgent.isSelected())
					{
						double alfa = Double.parseDouble(alfaValue.getText());
						double beta = Double.parseDouble(betaValue.getText());
						double gamma = Double.parseDouble(gammaValue.getText());
						double q0 = Double.parseDouble(qInitialValue.getText());
						behaviour = new QLearningBehaviour(environment.getAgents(), alfa, beta, gamma, q0);
					}

					agent.setKnownActions(environment.getActions());
					agent.setMoveController(moveController);
					agent.setBehaviour(behaviour);
					agent.reset();

					environment.addAgent(agent);
					// Agent //

					// Interaction Type
					InteractionType interactionType = null;
					if (interactions.isSelected())
					{
						int numberInteractions = Integer.parseInt(numberIntractionsPane.getText());
						interactionType = new NumberOfInteractionsInteractionType(numberInteractions);
					}
					else if (timeLimit.isSelected())
					{
						int timeLimitNumber = Integer.parseInt(timeLimitPane.getText());
						interactionType = new TimeLimitInteractionType(timeLimitNumber);
					}
					exercise.setInteractionType(interactionType);
					// Interaction Type //

					// Steps
					StepWaiting stepsWaiting = null;
					if (humanAgent.isSelected() == false)
					{
						if (changeStepsManually.isSelected())
							stepsWaiting = new StepByStepWaiting();
						else if (timeDelay.isSelected())
						{
							TimeDelayWaiting timeDelayWaiting = new TimeDelayWaiting();
							long timeDelayNumber = Long.parseLong(timeDelayPane.getText());
							timeDelayWaiting.setTimeDelay(timeDelayNumber);
							stepsWaiting = timeDelayWaiting;
						}
					}
					exercise.setStepWaiting(stepsWaiting);
					// Steps //

					// Reward Consumption Options
					if (beforeUpdate.isSelected())
					{
						environment.setRewardsConsumedBeforeRewardersUpdateCellRewards(true);
					}
					else if (afterUpdate.isSelected())
					{
						environment.setRewardsConsumedBeforeRewardersUpdateCellRewards(false);
					}

					if (numberRewardDecrease.isSelected())
					{
						int numberRewardDecrease = Integer.parseInt(factorDecreaseValuePane.getText());
						environment.setDecreaseFactor(numberRewardDecrease);
					}
					else if(infiniteDecreaseFactor.isSelected())
					{
						environment.setDecreaseFactor(Integer.MAX_VALUE);
					}

					if (consumeRewardsYes.isSelected())
					{
						environment.setEvaluableAgentConsumeRewards(true);
					}
					else if (consumeRewardsNo.isSelected())
					{
						environment.setEvaluableAgentConsumeRewards(false);
					}

					RewardsProvider rewardsSharing = null;
					if (shareRewardsYes.isSelected())
					{
						rewardsSharing = new ShareRewardsBetweenEvaluableAgents();
					}
					else if (shareRewardsNo.isSelected())
					{
						rewardsSharing = new NoShareRewards();
					}
					environment.setRewardsProvider(rewardsSharing);
					// Reward Consumption Options //

					agree();
				}
			});
		}
		return agree;
	}


	private void selectedHumanAgent()
	{
		changeStepsManually.setEnabled(false);
		timeDelay.setEnabled(false);
		timeDelayPane.setEnabled(false);
		timeDelayPane.setBackground(Color.LIGHT_GRAY);
		secondsTimeDelay.setEnabled(false);

		alfaLabel.setEnabled(false);
		betaLabel.setEnabled(false);
		gammaLabel.setEnabled(false);
		qInitialLabel.setEnabled(false);
		alfaValue.setEnabled(false);
		betaValue.setEnabled(false);
		gammaValue.setEnabled(false);
		qInitialValue.setEnabled(false);
		alfaValue.setBackground(Color.LIGHT_GRAY);
		betaValue.setBackground(Color.LIGHT_GRAY);
		gammaValue.setBackground(Color.LIGHT_GRAY);
		qInitialValue.setBackground(Color.LIGHT_GRAY);

		checkAgreeEnabled();
	}
	private void selectedTrivialFollowerAgent()
	{
		changeStepsManually.setEnabled(true);
		timeDelay.setEnabled(true);
		if (changeStepsManually.isSelected())
			changeStepsManually.doClick();
		else if (timeDelay.isSelected())
			timeDelay.doClick();

		alfaLabel.setEnabled(false);
		betaLabel.setEnabled(false);
		gammaLabel.setEnabled(false);
		qInitialLabel.setEnabled(false);
		alfaValue.setEnabled(false);
		betaValue.setEnabled(false);
		gammaValue.setEnabled(false);
		qInitialValue.setEnabled(false);
		alfaValue.setBackground(Color.LIGHT_GRAY);
		betaValue.setBackground(Color.LIGHT_GRAY);
		gammaValue.setBackground(Color.LIGHT_GRAY);
		qInitialValue.setBackground(Color.LIGHT_GRAY);

		checkAgreeEnabled();
	}
	private void selectedRandomAgent()
	{
		changeStepsManually.setEnabled(true);
		timeDelay.setEnabled(true);
		if (changeStepsManually.isSelected())
			changeStepsManually.doClick();
		else if (timeDelay.isSelected())
			timeDelay.doClick();

		alfaLabel.setEnabled(false);
		betaLabel.setEnabled(false);
		gammaLabel.setEnabled(false);
		qInitialLabel.setEnabled(false);
		alfaValue.setEnabled(false);
		betaValue.setEnabled(false);
		gammaValue.setEnabled(false);
		qInitialValue.setEnabled(false);
		alfaValue.setBackground(Color.LIGHT_GRAY);
		betaValue.setBackground(Color.LIGHT_GRAY);
		gammaValue.setBackground(Color.LIGHT_GRAY);
		qInitialValue.setBackground(Color.LIGHT_GRAY);

		checkAgreeEnabled();
	}
	private void selectedOracleAgent()
	{
		changeStepsManually.setEnabled(true);
		timeDelay.setEnabled(true);
		if (changeStepsManually.isSelected())
			changeStepsManually.doClick();
		else if (timeDelay.isSelected())
			timeDelay.doClick();
		alfaLabel.setEnabled(false);
		betaLabel.setEnabled(false);
		gammaLabel.setEnabled(false);
		qInitialLabel.setEnabled(false);
		alfaValue.setEnabled(false);
		betaValue.setEnabled(false);
		gammaValue.setEnabled(false);
		qInitialValue.setEnabled(false);
		alfaValue.setBackground(Color.LIGHT_GRAY);
		betaValue.setBackground(Color.LIGHT_GRAY);
		gammaValue.setBackground(Color.LIGHT_GRAY);
		qInitialValue.setBackground(Color.LIGHT_GRAY);

		checkAgreeEnabled();
	}
	private void selectedQLearningAgent()
	{
		changeStepsManually.setEnabled(true);
		timeDelay.setEnabled(true);
		if (changeStepsManually.isSelected())
			changeStepsManually.doClick();
		else if (timeDelay.isSelected())
			timeDelay.doClick();
		alfaLabel.setEnabled(true);
		betaLabel.setEnabled(true);
		gammaLabel.setEnabled(true);
		qInitialLabel.setEnabled(true);
		alfaValue.setEnabled(true);
		betaValue.setEnabled(true);
		gammaValue.setEnabled(true);
		qInitialValue.setEnabled(true);
		alfaValue.setBackground(Color.WHITE);
		betaValue.setBackground(Color.WHITE);
		gammaValue.setBackground(Color.WHITE);
		qInitialValue.setBackground(Color.WHITE);

		checkAgreeEnabled();
	}


	private void agree()
	{
		frame.agreeExercise();
	}

	/**
	 * This method initializes oracleAgent	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getOracleAgent() {
		if (oracleAgent == null) {
			oracleAgent = new JRadioButton();
			oracleAgent.setBounds(new Rectangle(300, 25, 65, 20));
			oracleAgent.setText("Oracle");
			oracleAgent.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectedOracleAgent();
				}
			});
		}
		return oracleAgent;
	}

	/**
	 * This method initializes qLearningAgent	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getQLearningAgent() {
		if (qLearningAgent == null) {
			qLearningAgent = new JRadioButton();
			qLearningAgent.setBounds(new Rectangle(383, 25, 97, 21));
			qLearningAgent.setText("Q Learning");
			qLearningAgent.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectedQLearningAgent();
				}
			});
		}
		return qLearningAgent;
	}

	/**
	 * This method initializes qLearningParameters	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getQLearningParameters() {
		if (qLearningParameters == null) {
			qInitialLabel = new JLabel();
			qInitialLabel.setBounds(new Rectangle(15, 100, 297, 16));
			qInitialLabel.setText("Q0: initial values for the Q-learning matrix (0.0 ... 2.0)");
			betaLabel = new JLabel();
			betaLabel.setBounds(new Rectangle(15, 50, 582, 20));
			betaLabel.setText("Beta : random exploration degree. Degree of randomness instead of optimal choice (0: optimal choice)");
			gammaLabel = new JLabel();
			gammaLabel.setBounds(new Rectangle(15, 75, 461, 20));
			gammaLabel.setText("Gamma: discount factor. Preference for long-term rewards (0: opportunistic)");
			alfaLabel = new JLabel();
			alfaLabel.setText("Alfa: learning rate. How important previous rewards are (0: learns infinitely slow)");
			alfaLabel.setBounds(new Rectangle(15, 25, 463, 20));
			qLearningParameters = new JPanel();
			qLearningParameters.setLayout(null);
			qLearningParameters.setBounds(new Rectangle(5, 69, 678, 126));
			qLearningParameters.setBorder(BorderFactory.createTitledBorder(null, "Agent Parameters", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			qLearningParameters.add(alfaLabel, null);
			qLearningParameters.add(gammaLabel, null);
			qLearningParameters.add(getAlfaValue(), null);
			qLearningParameters.add(getGammaValue(), null);
			qLearningParameters.add(betaLabel, null);
			qLearningParameters.add(getBetaValue(), null);
			qLearningParameters.add(qInitialLabel, null);
			qLearningParameters.add(getQInitialValue(), null);
		}
		return qLearningParameters;
	}

	/**
	 * This method initializes alfaValue	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getAlfaValue() {
		if (alfaValue == null) {
			alfaValue = new JTextPane();
			alfaValue.setBounds(new Rectangle(605, 25, 50, 20));
			alfaValue.setText("0.5");
			alfaValue.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			alfaValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return alfaValue;
	}

	/**
	 * This method initializes gammaValue	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getGammaValue() {
		if (gammaValue == null) {
			gammaValue = new JTextPane();
			gammaValue.setBounds(new Rectangle(605, 75, 50, 20));
			gammaValue.setText("0.5");
			gammaValue.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			gammaValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return gammaValue;
	}

	private void checkAgreeEnabled()
	{
		if (qLearningAgent.isSelected())
		{
			try
			{
				double alfa = Double.parseDouble(alfaValue.getText());
				double beta = Double.parseDouble(betaValue.getText());
				double gamma = Double.parseDouble(gammaValue.getText());
				double q0 = Double.parseDouble(qInitialValue.getText());
				if (alfa <= 0.0 || alfa > 1.0
				|| beta < 0.0 || beta > 1.0
				|| gamma < 0.0 || gamma >= 1.0
				|| q0 < 0.0 || q0 > 2.0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}

		if (!humanAgent.isSelected() && timeDelay.isSelected())
		{
			try
			{
				long timeDelayNumber = Long.parseLong(timeDelayPane.getText());
				if (timeDelayNumber < 0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}
		if (interactions.isSelected())
		{
			try
			{
				int interactionsNumber = Integer.parseInt(numberIntractionsPane.getText());
				if (interactionsNumber <= 0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}
		if (timeLimit.isSelected())
		{
			try
			{
				int timeLimit = Integer.parseInt(timeLimitPane.getText());
				if (timeLimit <= 0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}
		if (numberRewardDecrease.isSelected())
		{
			try
			{
				int decreaseFactor = Integer.parseInt(factorDecreaseValuePane.getText());
				if (decreaseFactor <= 0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}

		agreement.setEnabled(true);
		agree.setEnabled(true);
	}

	/**
	 * This method initializes betaValue	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getBetaValue() {
		if (betaValue == null) {
			betaValue = new JTextPane();
			betaValue.setBounds(new Rectangle(605, 50, 50, 20));
			betaValue.setText("0.5");
			betaValue.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			betaValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return betaValue;
	}

	/**
	 * This method initializes qInitialValue	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getQInitialValue() {
		if (qInitialValue == null) {
			qInitialValue = new JTextPane();
			qInitialValue.setBounds(new Rectangle(605, 100, 50, 20));
			qInitialValue.setText("1.0");
			qInitialValue.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			qInitialValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return qInitialValue;
	}
}