package investigation;


import interfaces.InvestigationTestInterface;
import javax.swing.JPanel;
import java.awt.Rectangle;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import java.awt.Color;

import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;

import distribution.IDistribution;
import distribution.UniversalDistribution;

import anynt.environment.LambdaEnvironment;
import anynt.object.RewardsGeneratorAgent;
import anynt.object.behaviour.AgentBehaviour;
import anynt.object.behaviour.PatternBehaviour;
import anynt.object.behaviour.RandomBehaviour;
import anynt.object.moveController.IAgentMoveController;
import anynt.object.moveController.NumberOfMovementsMoveController;
import anynt.object.moveController.PatternMoveController;


@SuppressWarnings("serial")
public class RewardsGeneratorsOptionsPanel extends JPanel
{
	private InvestigationTestInterface frame;
	private LambdaEnvironment environment;
	private RewardsGeneratorAgent goodAgent;
	private RewardsGeneratorAgent evilAgent;


	private JPanel rewardsGenerators = null;
	private JPanel movesPerStep = null;
	private JRadioButton nMovementsMC = null;
	private JRadioButton patternMC = null;
	private JRadioButton manualNMovementsMC = null;
	private JLabel nMovements = null;
	private JRadioButton UDNMovementsMC = null;
	private JLabel minimumUDNMovementsMC = null;
	private JLabel maximumUDNMovementsMC = null;
	private JComboBox manualNMovementsMCCombo = null;
	private JComboBox minimumUDNMovementsMCCombo = null;
	private JComboBox maximumUDNMovementsMCCombo = null;
	private JPanel behaviour = null;
	private JRadioButton patternBehaviour = null;
	private JRadioButton randomBehaviour = null;
	private JLabel pattern = null;
	private JRadioButton manualPatternBehaviour = null;
	private JRadioButton generatePatternBehaviour = null;
	private JLabel stopCriteria = null;
	private JTextField stopCriteriaValue = null;
	private JButton generatePattern = null;
	private JLabel patternGenerated = null;
	private JTextField patternGeneratedValue = null;
	private JLabel agreement = null;
	private JButton agree = null;
	private JTextField manualPatternBehaviourValue = null;

	private boolean changingComboValue = false;
	private JPanel relocate = null;
	private JRadioButton interactionsRelocate = null;
	private JTextField intearactionsValue = null;
	private JRadioButton interactionsNever = null;
	/**
	 * This is the default constructor
	 */
	public RewardsGeneratorsOptionsPanel(InvestigationTestInterface frame, LambdaEnvironment environment, RewardsGeneratorAgent goodAgent, RewardsGeneratorAgent evilAgent)
	{
		super();

		this.frame = frame;
		this.environment = environment;
		this.goodAgent = goodAgent;
		this.evilAgent = evilAgent;

		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		setLayout(null);
		setBounds(new Rectangle(0, 0, 940, 451));
		add(getRewardsGenerators(), null);

		patternMC.doClick();
		interactionsRelocate.doClick();
	}

	/**
	 * This method initializes rewardsGenerators	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getRewardsGenerators() {
		if (rewardsGenerators == null) {
			agreement = new JLabel();
			agreement.setBounds(new Rectangle(325, 330, 240, 20));
			agreement.setText("Do you agree with the reward generators?");
			agreement.setEnabled(false);
			rewardsGenerators = new JPanel();
			rewardsGenerators.setLayout(null);
			rewardsGenerators.setBounds(new Rectangle(15, 20, 910, 410));
			rewardsGenerators.setBorder(BorderFactory.createTitledBorder(null, "Behaviour of reward generators (Good and Evil)", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			rewardsGenerators.add(getMovesPerStep(), null);
			rewardsGenerators.add(getBehaviour(), null);
			rewardsGenerators.add(agreement, null);
			rewardsGenerators.add(getAgree(), null);
			rewardsGenerators.add(getRelocate(), null);
		}
		return rewardsGenerators;
	}

	/**
	 * This method initializes movesPerStep	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMovesPerStep() {
		if (movesPerStep == null) {
			maximumUDNMovementsMC = new JLabel();
			maximumUDNMovementsMC.setBounds(new Rectangle(180, 150, 130, 20));
			maximumUDNMovementsMC.setText("Maximum movements");
			minimumUDNMovementsMC = new JLabel();
			minimumUDNMovementsMC.setBounds(new Rectangle(180, 120, 125, 20));
			minimumUDNMovementsMC.setText("Minimum movements");
			nMovements = new JLabel();
			nMovements.setBounds(new Rectangle(15, 90, 155, 20));
			nMovements.setText("Specify fixed no. of actions");
			movesPerStep = new JPanel();
			movesPerStep.setLayout(null);
			movesPerStep.setBounds(new Rectangle(15, 20, 420, 185));
			movesPerStep.setBorder(BorderFactory.createTitledBorder(null, "No. of actions per step", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			movesPerStep.add(getNMovementsMC(), null);
			movesPerStep.add(getPatternMC(), null);
			movesPerStep.add(getManualNMovementsMC(), null);
			movesPerStep.add(nMovements, null);
			movesPerStep.add(getUDNMovementsMC(), null);
			movesPerStep.add(minimumUDNMovementsMC, null);
			movesPerStep.add(maximumUDNMovementsMC, null);
			movesPerStep.add(getManualNMovementsMCCombo(), null);
			movesPerStep.add(getMinimumUDNMovementsMCCombo(), null);
			movesPerStep.add(getMaximumUDNMovementsMCCombo(), null);

			ButtonGroup MCGroup = new ButtonGroup();
			MCGroup.add(getNMovementsMC());
			MCGroup.add(getPatternMC());

			ButtonGroup NMovementsMCGroup = new ButtonGroup();
			NMovementsMCGroup.add(getManualNMovementsMC());
			NMovementsMCGroup.add(getUDNMovementsMC());
		}
		return movesPerStep;
	}

	/**
	 * This method initializes nMovementsMC	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getNMovementsMC() {
		if (nMovementsMC == null) {
			nMovementsMC = new JRadioButton();
			nMovementsMC.setBounds(new Rectangle(15, 55, 235, 20));
			nMovementsMC.setText("Always perform a fixed no. of actions");
			nMovementsMC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectNMovementsMC();
				}
			});
		}
		return nMovementsMC;
	}

	/**
	 * This method initializes patternMC	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getPatternMC() {
		if (patternMC == null) {
			patternMC = new JRadioButton();
			patternMC.setBounds(new Rectangle(15, 30, 325, 20));
			patternMC.setText("Given by the pattern length or by an unallowed action");
			patternMC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectPatternMC();
				}
			});
		}
		return patternMC;
	}

	/**
	 * This method initializes manualNMovementsMC	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getManualNMovementsMC() {
		if (manualNMovementsMC == null) {
			manualNMovementsMC = new JRadioButton();
			manualNMovementsMC.setBounds(new Rectangle(15, 115, 70, 20));
			manualNMovementsMC.setText("Manual");
			manualNMovementsMC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectManualNMovementsMC();
				}
			});
		}
		return manualNMovementsMC;
	}

	/**
	 * This method initializes UDNMovementsMC	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getUDNMovementsMC() {
		if (UDNMovementsMC == null) {
			UDNMovementsMC = new JRadioButton();
			UDNMovementsMC.setBounds(new Rectangle(15, 145, 150, 20));
			UDNMovementsMC.setText("Universal distribution");
			UDNMovementsMC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectUDNMovementsMC();
				}
			});
		}
		return UDNMovementsMC;
	}

	/**
	 * This method initializes manualNMovementsMCCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getManualNMovementsMCCombo() {
		if (manualNMovementsMCCombo == null) {
			manualNMovementsMCCombo = new JComboBox();
			manualNMovementsMCCombo.setBounds(new Rectangle(100, 115, 45, 20));
			int maxNumberOfMovements = environment.getSpace().getNumberOfCells() - 1;
			constructIntegerComboValues(manualNMovementsMCCombo, 1, maxNumberOfMovements);
		}
		return manualNMovementsMCCombo;
	}

	/**
	 * This method initializes minimumUDNMovementsMCCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMinimumUDNMovementsMCCombo() {
		if (minimumUDNMovementsMCCombo == null) {
			minimumUDNMovementsMCCombo = new JComboBox();
			minimumUDNMovementsMCCombo.setBounds(new Rectangle(320, 120, 45, 20));
			int maxNumberOfMovements = environment.getSpace().getNumberOfCells() - 1;
			constructIntegerComboValues(minimumUDNMovementsMCCombo, 1, maxNumberOfMovements);
			minimumUDNMovementsMCCombo.setSelectedItem(1);
			minimumUDNMovementsMCCombo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (changingComboValue == false)
					{
						changingComboValue = true;
						changedMinimumMovements();
						changingComboValue = false;
					}
				}
			});
		}
		return minimumUDNMovementsMCCombo;
	}

	/**
	 * This method initializes maximumUDNMovementsMCCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMaximumUDNMovementsMCCombo() {
		if (maximumUDNMovementsMCCombo == null) {
			maximumUDNMovementsMCCombo = new JComboBox();
			maximumUDNMovementsMCCombo.setBounds(new Rectangle(320, 150, 45, 20));
			int maxNumberOfMovements = environment.getSpace().getNumberOfCells() - 1;
			constructIntegerComboValues(maximumUDNMovementsMCCombo, 1, maxNumberOfMovements);
			maximumUDNMovementsMCCombo.setSelectedItem(maxNumberOfMovements);
			maximumUDNMovementsMCCombo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (changingComboValue == false)
					{
						changingComboValue = true;
						changedMaximumMovements();
						changingComboValue = false;
					}
				}
			});
		}
		return maximumUDNMovementsMCCombo;
	}


	private void selectNMovementsMC()
	{
		manualNMovementsMC.setEnabled(true);
		UDNMovementsMC.setEnabled(true);
		nMovements.setEnabled(true);

		UDNMovementsMC.doClick();
		randomBehaviour.setEnabled(true);
	}
	private void selectPatternMC()
	{
		manualNMovementsMC.setEnabled(false);
		UDNMovementsMC.setEnabled(false);
		nMovements.setEnabled(false);

		manualNMovementsMCCombo.setEnabled(false);
		minimumUDNMovementsMC.setEnabled(false);
		maximumUDNMovementsMC.setEnabled(false);
		minimumUDNMovementsMCCombo.setEnabled(false);
		maximumUDNMovementsMCCombo.setEnabled(false);

		patternBehaviour.doClick();
		randomBehaviour.setEnabled(false);
	}
	private void selectManualNMovementsMC()
	{
		manualNMovementsMCCombo.setEnabled(true);
		minimumUDNMovementsMC.setEnabled(false);
		maximumUDNMovementsMC.setEnabled(false);
		minimumUDNMovementsMCCombo.setEnabled(false);
		maximumUDNMovementsMCCombo.setEnabled(false);
	}
	private void selectUDNMovementsMC()
	{
		manualNMovementsMCCombo.setEnabled(false);
		minimumUDNMovementsMC.setEnabled(true);
		maximumUDNMovementsMC.setEnabled(true);
		minimumUDNMovementsMCCombo.setEnabled(true);
		maximumUDNMovementsMCCombo.setEnabled(true);
	}

	/**
	 * This method initializes behaviour	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBehaviour() {
		if (behaviour == null) {
			patternGenerated = new JLabel();
			patternGenerated.setBounds(new Rectangle(15, 180, 45, 20));
			patternGenerated.setText("Pattern");
			stopCriteria = new JLabel();
			stopCriteria.setBounds(new Rectangle(15, 155, 350, 20));
			stopCriteria.setText("Pattern length factor (stop probability is inverse to this factor)");
			pattern = new JLabel();
			pattern.setBounds(new Rectangle(15, 65, 113, 20));
			pattern.setText("Pattern description");
			behaviour = new JPanel();
			behaviour.setLayout(null);
			behaviour.setBounds(new Rectangle(450, 20, 445, 215));
			behaviour.setBorder(BorderFactory.createTitledBorder(null, "Type of behaviour", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			behaviour.add(getPatternBehaviour(), null);
			behaviour.add(getRandomBehaviour(), null);

			behaviour.add(pattern, null);
			behaviour.add(getManualPatternBehaviour(), null);
			behaviour.add(getGeneratePatternBehaviour(), null);
			behaviour.add(stopCriteria, null);
			behaviour.add(getStopCriteriaValue(), null);
			behaviour.add(getGeneratePattern(), null);
			behaviour.add(patternGenerated, null);
			behaviour.add(getPatternGeneratedValue(), null);

			behaviour.add(getManualPatternBehaviourValue(), null);
			ButtonGroup behaviourGroup = new ButtonGroup();
			behaviourGroup.add(getPatternBehaviour());
			behaviourGroup.add(getRandomBehaviour());

			ButtonGroup patternDecisionGroup = new ButtonGroup();
			patternDecisionGroup.add(getManualPatternBehaviour());
			patternDecisionGroup.add(getGeneratePatternBehaviour());
		}
		return behaviour;
	}

	/**
	 * This method initializes patternBehaviour	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getPatternBehaviour() {
		if (patternBehaviour == null) {
			patternBehaviour = new JRadioButton();
			patternBehaviour.setBounds(new Rectangle(15, 30, 115, 20));
			patternBehaviour.setText("Follow a pattern");
			patternBehaviour.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectPatternBehaviour();
				}
			});
		}
		return patternBehaviour;
	}

	/**
	 * This method initializes randomBehaviour	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRandomBehaviour() {
		if (randomBehaviour == null) {
			randomBehaviour = new JRadioButton();
			randomBehaviour.setBounds(new Rectangle(145, 30, 115, 20));
			randomBehaviour.setText("Move randomly");
			randomBehaviour.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectRandomBehaviour();
				}
			});
		}
		return randomBehaviour;
	}

	/**
	 * This method initializes manualPatternBehaviour	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getManualPatternBehaviour() {
		if (manualPatternBehaviour == null) {
			manualPatternBehaviour = new JRadioButton();
			manualPatternBehaviour.setBounds(new Rectangle(15, 90, 130, 20));
			manualPatternBehaviour.setText("Describe manually");
			manualPatternBehaviour.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectManualPatternBehaviour();
				}
			});
		}
		return manualPatternBehaviour;
	}

	/**
	 * This method initializes generatePatternBehaviour	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getGeneratePatternBehaviour() {
		if (generatePatternBehaviour == null) {
			generatePatternBehaviour = new JRadioButton();
			generatePatternBehaviour.setBounds(new Rectangle(15, 120, 415, 20));
			generatePatternBehaviour.setSelected(true);
			generatePatternBehaviour.setText("Generate pattern randomly (unif. dist. on actions, univ. dist. on length)");
			generatePatternBehaviour.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectGeneratePatternBehaviour();
				}
			});
		}
		return generatePatternBehaviour;
	}

	/**
	 * This method initializes stopCriteriaValue	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getStopCriteriaValue() {
		if (stopCriteriaValue == null) {
			stopCriteriaValue = new JTextField();
			stopCriteriaValue.setBounds(new Rectangle(380, 155, 40, 20));
			stopCriteriaValue.setText("10");
			stopCriteriaValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkGeneratePatternEnabled();
				}
			});
		}
		return stopCriteriaValue;
	}

	/**
	 * This method initializes generatePattern	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getGeneratePattern() {
		if (generatePattern == null) {
			generatePattern = new JButton();
			generatePattern.setBounds(new Rectangle(300, 180, 115, 20));
			generatePattern.setText("Generate");
			generatePattern.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					generatePattern();
				}
			});
		}
		return generatePattern;
	}

	/**
	 * This method initializes patternGeneratedValue	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPatternGeneratedValue() {
		if (patternGeneratedValue == null) {
			patternGeneratedValue = new JTextField();
			patternGeneratedValue.setBounds(new Rectangle(75, 180, 200, 20));
			patternGeneratedValue.setBackground(Color.white);
			patternGeneratedValue.setEditable(false);
		}
		return patternGeneratedValue;
	}


	private void selectPatternBehaviour()
	{
		pattern.setEnabled(true);
		manualPatternBehaviour.setEnabled(true);
		generatePatternBehaviour.setEnabled(true);
		if (generatePatternBehaviour.isSelected())
		{
			stopCriteria.setEnabled(true);
			stopCriteriaValue.setEnabled(true);
			patternGenerated.setEnabled(true);
			patternGeneratedValue.setEnabled(true);
			checkGeneratePatternEnabled();
		}

		checkAgreeEnabled();
	}
	private void selectRandomBehaviour()
	{
		pattern.setEnabled(false);
		manualPatternBehaviour.setEnabled(false);
		generatePatternBehaviour.setEnabled(false);
		stopCriteria.setEnabled(false);
		stopCriteriaValue.setEnabled(false);
		patternGenerated.setEnabled(false);
		patternGeneratedValue.setEnabled(false);
		generatePattern.setEnabled(false);

		checkAgreeEnabled();
	}
	private void selectManualPatternBehaviour()
	{
		manualPatternBehaviourValue.setEnabled(true);
		stopCriteria.setEnabled(false);
		stopCriteriaValue.setEnabled(false);
		patternGenerated.setEnabled(false);
		patternGeneratedValue.setEnabled(false);
		generatePattern.setEnabled(false);

		checkAgreeEnabled();
	}
	private void selectGeneratePatternBehaviour()
	{
		manualPatternBehaviourValue.setEnabled(false);
		stopCriteria.setEnabled(true);
		stopCriteriaValue.setEnabled(true);
		patternGenerated.setEnabled(true);
		patternGeneratedValue.setEnabled(true);

		checkGeneratePatternEnabled();
		checkAgreeEnabled();
	}
	private void checkGeneratePatternEnabled()
	{
		try
		{
			int stopCriteria = Integer.parseInt(stopCriteriaValue.getText());
			if (stopCriteria <= 0)
				throw new NumberFormatException();

			generatePattern.setEnabled(true);
		}
		catch (NumberFormatException e)
		{
			generatePattern.setEnabled(false);
		}
	}

	private void changedMinimumMovements()
	{
		int minimumCells = (Integer) minimumUDNMovementsMCCombo.getSelectedItem();
		int maxNumberOfMovements = environment.getSpace().getNumberOfCells() - 1;
		constructIntegerComboValues(maximumUDNMovementsMCCombo, minimumCells, maxNumberOfMovements);
	}
	private void changedMaximumMovements()
	{
		int maximumCells = (Integer) maximumUDNMovementsMCCombo.getSelectedItem();
		constructIntegerComboValues(minimumUDNMovementsMCCombo, 2, maximumCells);
	}

	private void constructIntegerComboValues(JComboBox combo, int startNumber, int maxNumber)
	{
		Object selectedNumber = combo.getSelectedItem();
		combo.removeAllItems();
		for (int index = startNumber; index <= maxNumber; index++)
			combo.addItem(index);
		combo.setSelectedItem(selectedNumber);
		if (combo.getSelectedIndex() < 0)
			combo.setSelectedIndex(0);
	}


	private boolean validPatternDescription(String description)
	{
		if (description.length() == 0)
			return false;

		for (int index = 0; index < description.length(); index++)
			try
			{
				Integer.parseInt(description.charAt(index) + "");
			}
			catch (NumberFormatException e)
			{
				return false;
			}

		return true;
	}
	private void generatePattern()
	{
		int[] actions = environment.getActions();
		int stopCriteria = Integer.parseInt(stopCriteriaValue.getText());

		patternGeneratedValue.setText(PatternBehaviour.generatePattern(actions, stopCriteria));
		checkAgreeEnabled();
	}

	/**
	 * This method initializes agree	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAgree() {
		if (agree == null) {
			agree = new JButton();
			agree.setBounds(new Rectangle(366, 365, 150, 30));
			agree.setText("Agree");
			agree.setEnabled(false);
			agree.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					agree();
				}
			});
		}
		return agree;
	}

	private void checkAgreeEnabled()
	{
		if (interactionsRelocate.isSelected())
		{
			try
			{
				int interactionsRelocate = Integer.parseInt(intearactionsValue.getText());
				if (interactionsRelocate <= 0)
					throw new NumberFormatException();
			}
			catch (NumberFormatException e)
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
				return;
			}
		}

		if (patternBehaviour.isSelected())
		{
			if (manualPatternBehaviour.isSelected()
				&& validPatternDescription(manualPatternBehaviourValue.getText())
			|| generatePatternBehaviour.isSelected()
				&& !patternGeneratedValue.getText().equals(""))
			{
				agreement.setEnabled(true);
				agree.setEnabled(true);
			}
			else
			{
				agreement.setEnabled(false);
				agree.setEnabled(false);
			}
		}
		else if (randomBehaviour.isSelected())
		{
			agreement.setEnabled(true);
			agree.setEnabled(true);
		}
	}

	/**
	 * This method initializes manualPatternBehaviourValue	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getManualPatternBehaviourValue() {
		if (manualPatternBehaviourValue == null) {
			manualPatternBehaviourValue = new JTextField();
			manualPatternBehaviourValue.setBounds(new Rectangle(160, 90, 260, 20));
			manualPatternBehaviourValue.setEnabled(false);
			manualPatternBehaviourValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return manualPatternBehaviourValue;
	}

	private void agree()
	{
		IAgentMoveController moveController = null;
		if (nMovementsMC.isSelected())
		{
			moveController = new NumberOfMovementsMoveController();
			int movements = 2;
			if (manualNMovementsMC.isSelected())
				movements = (Integer) manualNMovementsMCCombo.getSelectedItem();
			else if (UDNMovementsMC.isSelected())
			{
				IDistribution d = new UniversalDistribution();
				movements = d.getValue((Integer) minimumUDNMovementsMCCombo.getSelectedItem(), (Integer) maximumUDNMovementsMCCombo.getSelectedItem());
			}
			((NumberOfMovementsMoveController) moveController).setNumberOfMovements(movements);
		}
		else if (patternMC.isSelected())
			moveController = new PatternMoveController();

		AgentBehaviour goodBehaviour = null;
		AgentBehaviour evilBehaviour = null;
		if (patternBehaviour.isSelected())
		{
			if (manualPatternBehaviour.isSelected())
				goodBehaviour = new PatternBehaviour(manualPatternBehaviourValue.getText());
			else if (generatePatternBehaviour.isSelected())
				goodBehaviour = new PatternBehaviour(patternGeneratedValue.getText());
		}
		else if (randomBehaviour.isSelected())
			goodBehaviour = new RandomBehaviour();

		int interactionsToRelocate = 0;
		if (interactionsRelocate.isSelected())
			interactionsToRelocate = Integer.parseInt(intearactionsValue.getText());
		else if (interactionsNever.isSelected())
			interactionsToRelocate = 0;

		evilBehaviour = goodBehaviour.clone();

		goodAgent.setKnownActions(environment.getActions());
		goodAgent.setMoveController(moveController);
		goodAgent.setBehaviour(goodBehaviour);
		goodAgent.reset();
		evilAgent.setKnownActions(environment.getActions());
		evilAgent.setMoveController(moveController);
		evilAgent.setBehaviour(evilBehaviour);
		evilAgent.reset();

		environment.setInteractionsToRelocateRewarders(interactionsToRelocate);

		frame.agreeRewardsGenerators();
	}

	/**
	 * This method initializes relocate	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getRelocate() {
		if (relocate == null) {
			relocate = new JPanel();
			relocate.setLayout(null);
			relocate.setBounds(new Rectangle(15, 220, 420, 95));
			relocate.setBorder(BorderFactory.createTitledBorder(null, "Generators relocation", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			relocate.add(getInteractionsRelocate(), null);
			relocate.add(getIntearactionsValue(), null);
			relocate.add(getInteractionsNever(), null);

			ButtonGroup relocateGroup = new ButtonGroup();
			relocateGroup.add(getInteractionsRelocate());
			relocateGroup.add(getInteractionsNever());
		}
		return relocate;
	}

	/**
	 * This method initializes interactionsRelocate	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getInteractionsRelocate() {
		if (interactionsRelocate == null) {
			interactionsRelocate = new JRadioButton();
			interactionsRelocate.setBounds(new Rectangle(15, 30, 300, 20));
			interactionsRelocate.setText("Randomly relocate the generators after n steps:");
			interactionsRelocate.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					intearactionsValue.setEnabled(true);
					intearactionsValue.setBackground(Color.WHITE);
					checkAgreeEnabled();
				}
			});
		}
		return interactionsRelocate;
	}

	/**
	 * This method initializes intearactionsValue	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getIntearactionsValue() {
		if (intearactionsValue == null) {
			intearactionsValue = new JTextField();
			intearactionsValue.setBounds(new Rectangle(320, 30, 85, 20));
			intearactionsValue.setText("25");
			intearactionsValue.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					checkAgreeEnabled();
				}
			});
		}
		return intearactionsValue;
	}

	/**
	 * This method initializes interactionsNever	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getInteractionsNever() {
		if (interactionsNever == null) {
			interactionsNever = new JRadioButton();
			interactionsNever.setBounds(new Rectangle(15, 60, 110, 20));
			interactionsNever.setText("Never relocate");
			interactionsNever.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					intearactionsValue.setEnabled(false);
					intearactionsValue.setBackground(Color.LIGHT_GRAY);
					checkAgreeEnabled();
				}
			});
		}
		return interactionsNever;
	}
}